package com.qiaoba.common.database.filters;

import com.qiaoba.common.database.config.DynamicDataSourceContext;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

/**
 * 动态切换不同租户的数据源
 *
 * @author ailanyin
 * @version 1.0
 * @since 2023-04-25 22:48:43
 */
@Component
@Order(-10000)
public class HandleTenantFilter implements Filter {

    @Resource
    private DynamicDataSourceContext dynamicDataSourceContext;

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        String instanceId = request.getParameter("tenant");
        //设置当前租户对应的数据库
        dynamicDataSourceContext.setDataSource(instanceId);
        System.out.println("当前数据源是:" + dynamicDataSourceContext.getDataSource());
        filterChain.doFilter(servletRequest, servletResponse);
        dynamicDataSourceContext.clearDataSource();
    }
}
