package com.qiaoba.module.system.controller;

import cn.hutool.core.util.RandomUtil;
import com.qiaoba.api.system.entity.SysUser;
import com.qiaoba.api.system.entity.param.SysUserParam;
import com.qiaoba.module.system.service.SysUserService;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户管理 web层
 *
 * @author ailanyin
 * @version 1.0
 * @since 2023-04-23 20:51:26
 */
@RestController
@RequestMapping("/system/user")
@Tag(name = "用户管理")
public class SysUserController {

    @Resource
    private SysUserService baseService;

    @GetMapping("/add")
    public String add() {
        SysUser sysUser = new SysUser();
        sysUser.setUsername(RandomUtil.randomString(8));
        sysUser.setNickname(RandomUtil.randomString(8));
        sysUser.setIsSuperuser(false);
        sysUser.setIsDelete(true);
        sysUser.setIsManager(true);
        baseService.insert(sysUser);
        return "OK";
    }

    @GetMapping("/list")
    public List<SysUser> list(@RequestParam String name) {
        SysUserParam dto = new SysUserParam();
        dto.setNickname(name);
        return baseService.selectList(dto);
    }
}
