package com.qiaoba.module.system.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.qiaoba.api.system.entity.SysUser;
import com.qiaoba.api.system.entity.param.SysUserParam;
import com.qiaoba.module.system.mapper.SysUserMapper;
import com.qiaoba.module.system.service.SysUserService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户管理 服务层实现
 *
 * @author ailanyin
 * @version 1.0
 * @since 2023-04-23 20:38:09
 */
@Service
public class SysUserServiceImpl implements SysUserService {

    @Resource
    private SysUserMapper baseMapper;

    @Override
    public int insert(SysUser sysUser) {
        return baseMapper.insert(sysUser);
    }

    @Override
    public int update(SysUser sysUser) {
        return baseMapper.updateById(sysUser);
    }

    @Override
    public List<SysUser> selectList(SysUserParam sysUserParam) {
        return baseMapper.selectList(param2Wrapper(sysUserParam));
    }

    private QueryWrapper<SysUser> param2Wrapper(SysUserParam sysUserParam) {
        QueryWrapper<SysUser> wrapper = new QueryWrapper<>();
        wrapper.lambda().like(StrUtil.isNotBlank(sysUserParam.getNickname()), SysUser::getNickname, sysUserParam.getNickname());
        return wrapper;
    }
}
